
#ifndef ATOM_H
#define ATOM_H

#include "coordinate3D.h"
#include "element.h"
#include "elementBuilder.h"

#include <stdio.h>

class Atom {

 public:
  Atom(ElementBuilder* eb, char* symbol, float x, float y, float z);
  Atom(ElementBuilder* eb, char* symbol, Coordinate3D* c);
  Atom(ElementBuilder* eb, char* symbol, float x, float y, float z, float ch);
  Atom(ElementBuilder* eb, char* symbol, Coordinate3D* c, float ch);
  ~Atom();

  Coordinate3D* getCoordinate3D();
  float getCharge();
  int isWithinVdwRadius(Coordinate3D* c);

 private:
  Element* element;
  Coordinate3D* coord;
  float charge;

};

#endif
