
#ifndef BASEVERTEXNODETREE_H
#define BASEVERTEXNODETREE_H

#include "baseVertexNode.h"
#include "coordinate3D.h"


class BaseVertexNodeTree {

 public:
  /**
   * Constructor.
   * @param v BaseVertexNode*: object to be stored in the tree; lookup key is contained within this object.
   */
  BaseVertexNodeTree(BaseVertexNode* v);

  /**
   * Destructor.
   */
  ~BaseVertexNodeTree();

  /**
   * Add a node to the tree.
   * @param node BaseVertexNode*: node to add.
   * @return int: 0 on fail, 1 on success.
   */
  int insert(BaseVertexNode* node);

  /**
   * Retrieve an object stored in the tree.
   * @param coord Coordinate3D*: lookup key.
   * @return BaseVertexNode*: retrieved object.
   */
  BaseVertexNode* retrieve(Coordinate3D* coord);

 private:
  BaseVertexNode* vertex;
  BaseVertexNodeTree* child1;
  BaseVertexNodeTree* child2;

};

#endif
