
#ifndef CONNECTIONMATRIX_H
#define CONNECTIONMATRIX_H

#include <stdio.h>


class ConnectionNode {

 public:
  ConnectionNode(int i, int val);
  ~ConnectionNode();

  //ConnectionNode* getPrevious();
  ConnectionNode* getNext();
  int getIndex();
  int getValue();
  //int setPrevious(ConnectionNode* b);
  int setNext(ConnectionNode* n);
  int setValue(int val);

 private:
  //ConnectionNode* before;
  ConnectionNode* next;
  int index;
  int value;

};


class ConnectionList {

 public:
  ConnectionList();
  ~ConnectionList();

  int getValue(int i);
  int setValue(int i, int value);
  int incrementValues();
  int removeIfGreaterThan(float limit);

 private:
  int add(int i, int value);
  int remove(int i);

 private:
  ConnectionNode* head;

};


class ConnectionMatrix {

 public:
  ConnectionMatrix(int l);
  ~ConnectionMatrix();

  int getValue(int i, int j);
  int setValue(int i, int j, int value);
  int incrementValues();
  int removeIfGreaterThan(float limit);

 private:

 private:
  ConnectionList** conList;
  int listLength;

};
#endif
