
#include "coordinate3D.h"


Coordinate3D::Coordinate3D(float a, float b, float c) :
  x(a),y(b),z(c) {
  /*
  coords[0] = a;
  coords[1] = b;
  coords[2] = c;
  */
  return;
}


Coordinate3D::~Coordinate3D() {

  //delete[] coords;

  return;
}


int Coordinate3D::equals(Coordinate3D* coord) {
  /*
  if ( coord->getX() != coords[0] ||
       coord->getY() != coords[1] ||
       coord->getZ() != coords[2] ) {
    return 0;
  }
  */
  if ( coord->getX() != x ||
       coord->getY() != y ||
       coord->getZ() != z ) {
    return 0;
  }
    
  return 1;
}


int Coordinate3D::isGreaterThan(Coordinate3D* coord) {
  /*
  if ( coord->getX() > coords[0]) {
    return 1;
  }
  if ( coord->getX() == coords[0]) {
    if ( coord->getY() > coords[1] ) {
      return 1;
    }
    if ( coord->getY() == coords[1] ) {
      if ( coord->getZ() > coords[2] ) {
	return 1;
      }
    }
  }
  */

  if ( coord->getX() > x) {
    return 1;
  }
  if ( coord->getX() == x) {
    if ( coord->getY() > y ) {
      return 1;
    }
    if ( coord->getY() == y ) {
      if ( coord->getZ() > z ) {
	return 1;
      }
    }
  }

  return 0;
}


int Coordinate3D::isLessThan(Coordinate3D* coord) {
  /*
  if ( coord->getX() < coords[0]) {
    return 1;
  }
  if ( coord->getX() == coords[0]) {
    if ( coord->getY() < coords[1] ) {
      return 1;
    }
    if ( coord->getY() == coords[1] ) {
      if ( coord->getZ() < coords[2] ) {
	return 1;
      }
    }
  }
  */

  if ( coord->getX() < x) {
    return 1;
  }
  if ( coord->getX() == x) {
    if ( coord->getY() < y ) {
      return 1;
    }
    if ( coord->getY() == y ) {
      if ( coord->getZ() < z ) {
	return 1;
      }
    }
  }

  return 0;
}


float Coordinate3D::getX() {

  return x;
}


float Coordinate3D::getY() {
  
  return y;
}


float Coordinate3D::getZ() {

  return z;
}


void Coordinate3D::setX(float a) {

  x = a;
  return;
}


void Coordinate3D::setY(float b) {
  
  y = b;
  return;
}


void Coordinate3D::setZ(float c) {

  z = c;
  return;
}


// getDistanceTo - returns the Euclidean distance between this and coord;
//   returns -1.0 on error;
float Coordinate3D::getDistanceTo(Coordinate3D* coord) {

  if (coord == 0) {
    return -1.0;
  }

  float distance = sqrt( pow(x - coord->getX(),2) +
			 pow(y - coord->getY(),2) +
			 pow(z - coord->getZ(),2) );
  
  return distance;
}


// clone
//
Coordinate3D* Coordinate3D::clone() {

  return new Coordinate3D(x,y,z);
}



Coordinate3D* Coordinate3D::plus(Coordinate3D* coord) {

  float x1 = x + coord->getX();
  float y1 = y + coord->getY();
  float z1 = z + coord->getZ();

  return new Coordinate3D(x1,y1,z1);
}


Coordinate3D* Coordinate3D::minus(Coordinate3D* coord) {

  float x1 = x - coord->getX();
  float y1 = y - coord->getY();
  float z1 = z - coord->getZ();

  return new Coordinate3D(x1,y1,z1);
}


float Coordinate3D::dot(Coordinate3D* coord) {

  return ( (x * coord->getX()) +
	   (y * coord->getY()) +
	   (z * coord->getZ()) );
}


Coordinate3D* Coordinate3D::cross(Coordinate3D* coord) {

  float x1 = (y * coord->getZ()) - (z * coord->getY());
  float y1 = (z * coord->getX()) - (x * coord->getZ());
  float z1 = (x * coord->getY()) - (y * coord->getX());

  return new Coordinate3D(x1,y1,z1);
}

/**
 * Rotate the coordinate a radians about the X axis.
 * @param a float: angle of rotation in radians.
 * @return int: 0 on fail, 1 on success.
 */
int Coordinate3D::rotateX(float a) {


  float tempY = y*cos(a) - z*sin(a);
  float tempZ = y*sin(a) + z*cos(a);
  setY(tempY);
  setZ(tempZ);

  return 1;
}


/**
 * Rotate the coordinate a radians about the Y axis.
 * @param a float: angle of rotation in radians.
 * @return int: 0 on fail, 1 on success.
 */
int Coordinate3D::rotateY(float a) {

  float tempX = x*cos(a) - z*sin(a);
  float tempZ = x*sin(a) + z*cos(a);
  setX(tempX);
  setZ(tempZ);

  return 1;
}


/**
 * Rotate the coordinate a radians about the Z axis.
 * @param a float: angle of rotation in radians.
 * @return int: 0 on fail, 1 on success.
 */
int Coordinate3D::rotateZ(float a) {

  //printf("a = %3.2f, cos(a) = %3.2f, sin(a) = %3.2f\n",a,cos(a),sin(a));

  float tempX = x*cos(a) - y*sin(a);
  float tempY = x*sin(a) + y*cos(a);
  setX(tempX);
  setY(tempY);

  return 1;
}
