
#include "genericList.h"

// GenericListNode

template<class T> GenericListNode<T>::GenericListNode(T p) :
  previous(0), next(0) {

  package = p;

  return;
}


template<class T> GenericListNode<T>::~GenericListNode() {

  delete next;
  // XXX - might want to delete the packages

  return;
}


template<class T> T GenericListNode<T>::getPackage() {

  return package;
}


template<class T> GenericListNode<T>* GenericListNode<T>::getPrevious() {

  return previous;
}


template<class T> GenericListNode<T>* GenericListNode<T>::getNext() {

  return next;
}


template<class T> int GenericListNode<T>::setPrevious(GenericListNode* p) {

  previous = p;

  return 0;
}


template<class T> int GenericListNode<T>::setNext(GenericListNode* n) {

  next = n;

  return 0;
}


// GenericList

template<class T> GenericList<T>::GenericList() :
  head(0), tail(0), current(0), length(0) {

  return;
}


template<class T> GenericList<T>::~GenericList() {

  delete head;

  return;
}


template<class T> T GenericList<T>::getFirst() {

  if (head == 0) {
    return 0;
  }

  current = head;

  return head->getPackage();
}


template<class T> T GenericList<T>::getNext() {

  if (current->getNext() == 0) {
    return 0;
  }

  current = current->getNext();

  return current->getPackage();
}


template<class T> int GenericList<T>::getLength() {

  return length;
}


template<class T> T GenericList<T>::front() {

  if (head == 0) {
    return 0;
  }

  T tempT = head->getPackage();
  GenericListNode<T>* tempNode = head->getNext();

  // if (removing last node)
  if (tempNode == 0) {
    delete head;
    head = 0;
    current = 0;
    tail = 0;
    length--;
    return tempT;
  }

  head->setNext(0);
  delete head;
  head = tempNode;
  current = head;
  head->setPrevious(0);
  length--;

  return tempT;
}


template<class T> T GenericList<T>::pop() {

  if (tail == 0) {
    return 0;
  }

  T tempT = tail->getPackage();
  GenericListNode<T>* tempNode = tail->getPrevious();

  // if (removing last node)
  if (tempNode == 0) {
    delete tail;
    tail = 0;
    current = 0;
    head = 0;
    length--;
    return tempT;
  }

  delete tail;
  tail = tempNode;
  current = tail;
  tail->setNext(0);
  length--;
  
  return tempT;
}


template<class T> int GenericList<T>::push(T t) {

  //printf("=>GenericList<T>::push\n");
  //printf("  hey\n");

  if (tail == 0) {
    //printf("  tail == 0\n");
    GenericListNode<T>* tempNode = new GenericListNode<T>(t);
    head = tempNode;
    tail = tempNode;
    current = tempNode;
    length++;
    //printf("<=GenericList<T>::push\n");
    return 1;
  }

  //printf("tail != 0\n");
  GenericListNode<T>* tempNode = new GenericListNode<T>(t);
  //printf("  hey2\n");
  tail->setNext(tempNode);
  //printf("  hey3\n");
  tempNode->setPrevious(tail);
  //printf("  hey4\n");
  tail = tempNode;
  //printf("  hey5\n");
  current = tail;
  //printf("  hey6\n");
  length++;

  //printf("<=GenericList<T>::push\n");
  return 1;
}


template<class T> T GenericList<T>::returnElement(int index) {

  if (index > length-1) {
    printf("Error GenericList<T>::return index out of bounds\n");
    return 0;
  }

  if (index == 0) {
    current = head;
    return head->getPackage();
  }

  if (index == length-1) {
    current = tail;
    return tail->getPackage();
  }

  GenericListNode<T>* tempNode = head;
  int i=0;
  for (i=0; i<index; i++) {
    tempNode = tempNode->getNext();
  }
  current = tempNode;

  return tempNode->getPackage();
}


template<class T> T GenericList<T>::removeElement(int index) {

  //printf("=>GenericList<T>::removeElement\n");

  if (index > length-1) {
    printf("Error GenericList<T>::remove index out of bounds (index: %d, length: %d)\n",index,length);
    return 0;
  }

  if (index == 0) {
    return front();
  }

  if (index == length-1) {
    return pop();
  }

  GenericListNode<T>* tempNode = head;
  int i=0;
  for (i=0; i<index; i++) {
    tempNode = tempNode->getNext();
  }
  T tempPackage = tempNode->getPackage();
  tempNode->getPrevious()->setNext(tempNode->getNext());
  tempNode->getNext()->setPrevious(tempNode->getPrevious());
  tempNode->setPrevious(0);
  tempNode->setNext(0);
  delete tempNode;
  length--;

  //printf("<=GenericList<T>::removeElement\n");

  return tempPackage;
}


template<class T> GenericList<T>* GenericList<T>::clone() {
  
  GenericListNode<T>* tempCurrent = current;
  GenericList<T>* newList = new GenericList<T>();
  
  T element = getFirst();
  while (element != 0) {
    newList->push(element);
    element = getNext();
  }

  current = tempCurrent;

  return newList;
}


template<class T> int GenericList<T>::printList() {

  GenericListNode<T>* tempCurrent = current;

  T tempT = getFirst();
  printf("  list: ");
  int i=0;
  while (tempT != 0) {
    printf("%d ",i);
    tempT = getNext();
    i++;
  }
  printf("\n");

  current = tempCurrent;

  return 1;
}
