
#include "neuronList.h"


// Constructor
//
NeuronNode::NeuronNode(Coordinate3D* c, int i, float d) :
  next(0), prev(0), coord(c), index(i), distance(d) {
  //printf("NeuronNode::NeuronNode()\n");
  return;
}


// Destructor
//
NeuronNode::~NeuronNode() {

  if (next != 0) {
    delete next;
  }

  // DON'T DELETE COORDINATE3D

  return;
}


/*
// getNext
//
NeuronNode* NeuronNode::getNext() {

  return next;
}


// getPrev
//
NeuronNode* NeuronNode::getPrev() {

  return prev;
}
*/


// getCoord
//
Coordinate3D* NeuronNode::getCoord() {

  return coord;
}


// getIndex
//
int NeuronNode::getIndex() {

  return index;
}


// getDistance
//
float NeuronNode::getDistance() {

  return distance;
}


/*
// setNext
//
int NeuronNode::setNext(NeuronNode* n) {

  next = n;
  return 1;
}


// setPrev
//
int NeuronNode::setPrev(NeuronNode* p) {

  prev = p;
  return 1;
}


// isLessThan
//
int NeuronNode::isLessThan(NeuronNode* n) {

  if (distance < n->getDistance()) {
    return 1;
  }

  return 0;
}


// isGreaterThan
//
int NeuronNode::isGreaterThan(NeuronNode* n) {

  if (distance > n->getDistance()) {
    return 1;
  }

  return 0;
}
*/




// Constructor
//
NeuronList::NeuronList(Coordinate3D** coords, int coordCount, Coordinate3D* f) :
  focus(f), neuronCount(coordCount)  {

	//printf("=>NeuronList\n");
	//printf("  neuronCount = %d\n",neuronCount);
  /*
  // Load NeuronList with coordinates
  for (int i=0; i<neuronCount; i++) {
  addNeuronNode(coords[i], i, coords[i]->getDistanceTo(focus));
  //printf("<=NeuronList::addNeuronNode()\n");
  }
  */

  nodes = new NeuronNode*[neuronCount];
  for (int i=0; i<neuronCount; i++) {
	//printf("%d \n", i);
    nodes[i] = new NeuronNode(coords[i], i, coords[i]->getDistanceTo(focus));
  }
	//printf("\n");

  quicksortNodes(0,neuronCount-1);
  checkOrder();

	//printf("<=NeuronList\n");
  return;
}


// Destructor
//
NeuronList::~NeuronList() {

  //if (head != 0) {
  //delete head;
  //}

  for (int i=0; i<neuronCount; i++) {
    delete nodes[i];
  }
  delete nodes;

  // XXX - MAYBE DELETE FOCUS
  //delete focus;

  return;
}


/*
// addNeuronNode
//
int NeuronList::addNeuronNode(Coordinate3D* coord, int index, float distance) {

//printf("=>NeuronList::addNeuronNode()\n");
//printf("   index: %d, distance: %3.2f\n",index,distance);

NeuronNode* node = new NeuronNode(coord, index, distance);

if (head == 0) {
head = node;
current = node;
//printf("   head == 0\n");
return 1;
}

//printf("   Hey1\n");
NeuronNode* tempNode1 = current;
NeuronNode* tempNode2 = current;
//printf("   Hey2\n");

// Move down the list to the right
if (distance >= tempNode2->distance) {
//printf("   in if 1\n");
tempNode1 = tempNode1->next;
while ( tempNode1 != 0 &&
distance > tempNode1->distance ) {
tempNode2 = tempNode1;
tempNode1 = tempNode1->next;
}
if (tempNode1 == 0) {
tempNode2->setNext(node);
node->setPrev(tempNode2);
//printf("   return 1\n");
return 1;
}
tempNode2->setNext(node);
node->setPrev(tempNode2);
tempNode1->setPrev(node);
node->setNext(tempNode1);
//printf("   return 2\n");
return 1;
}

// Move down the list to the left
if (distance < tempNode2->distance) {
//printf("   in if 2\n");
tempNode1 = tempNode1->prev;
while ( tempNode1 != 0 &&
distance < tempNode1->distance ) {
tempNode2 = tempNode1;
tempNode1 = tempNode1->prev;
}
if (tempNode1 == 0) {
tempNode2->setPrev(node);
node->setNext(tempNode2);
head = node;
//printf("   return 3\n");
return 1;
}
tempNode2->setPrev(node);
node->setNext(tempNode2);
tempNode1->setNext(node);
node->setPrev(tempNode1);
//printf("   return 4\n");
return 1;
}

//printf("   return 5\n");
return 0;
}
*/


// getFirstIndex
//
int NeuronList::getFirstIndex() {

  //if (head != 0) {
  //return head->getIndex();
  //}

  if (nodes[0] != 0) {
    //Coordinate3D* n = nodes[0]->getCoord();
    //printf("  1st %d: (%f,%f,%f)\n",nodes[0]->getIndex(),n->getX(),n->getY(),n->getZ());
    return nodes[0]->getIndex();
  }
  else {
    printf("NeuronList::getFirstIndex() - Error!\n");
  }


  return 0;
}


// getSecondIndex
//
int NeuronList::getSecondIndex() {

  //if (head != 0 && head->getNext() != 0) {
  //return head->getNext()->getIndex();
  //}

  if (nodes[1] != 0) {
    //Coordinate3D* n = nodes[1]->getCoord();
    //printf("  2nd %d: (%f,%f,%f)\n",nodes[1]->getIndex(),n->getX(),n->getY(),n->getZ());
    return nodes[1]->getIndex();
  }
  else {
    printf("NeuronList::getSecondIndex() - Error!\n");
  }

  return 0;
}


// contract
//   Move all the coordinates towards the focus
int NeuronList::contract(float stepSize, float lambda) {

  //printf("\n    stepSize: %f, lambda: %f\n",stepSize,lambda);

  if (stepSize == 0 || lambda == 0) {
    // Don't contract
    return 1;
  }

  //NeuronNode* tempNode = 0;
  Coordinate3D* coord = 0;
  //int negCount = -1 * neuronCount;
  float coeff = 0.0;
  float x = 0.0;
  float y = 0.0;
  float z = 0.0;
  //while (tempNode != 0) {
  for (int i=0; i < neuronCount; i++) {
    //printf("%d:%f ",nodes[i]->getIndex(),nodes[i]->getDistance());
    //if (i%10 == 0) {
    //  printf("\n");
    //}
    coord = nodes[i]->getCoord();
    /*
    x = focus->getX() - coord->getX();
    y = focus->getY() - coord->getY();
    z = focus->getZ() - coord->getZ();
    */
    // NEW {
    x = focus->getX() - coord->getX();
    y = focus->getY() - coord->getY();
    z = focus->getZ() - coord->getZ();
    // } NEW
    coeff = stepSize * exp( (-1 * i) / lambda );
    //coeff = stepSize * exp( i / lambda );   // NEW
    x *= coeff;
    y *= coeff;
    z *= coeff;
    /*
    coord->setX( coord->getX() + x );
    coord->setY( coord->getY() + y );
    coord->setZ( coord->getZ() + z );
    */
    // NEW {
    coord->setX(coord->getX() + x);
    coord->setY(coord->getY() + y);
    coord->setZ(coord->getZ() + z);
    //coord->coords[0] += x;
    //coord->coords[1] += y;
    //coord->coords[2] += z;
    // } NEW
    //tempNode = tempNode->next;
    //i++;
    //i--;   // NEW
  }

  return 1;
}


// quicksortNodes
//   Use quicksort to order the nodes by distance from focus
int NeuronList::quicksortNodes(int first, int last) {

  //printf("=>NeuronList::quicksortNodes(%d,%d)\n",first,last);
  //if (first == last-1 || first == last) {
  //printf("(%d,%d) (%f,%f)\n",first,last,nodes[first]->distance,nodes[last]->distance);
    //}

  int i = first-1;
  int j = last+1;
  int flag = 0;
  float pivot = nodes[first]->distance;

  // Partition array into 2 segments about pivot: lower distances, higher distances
  while (flag == 0) {
    //printf("   (%d,%d)\n",i,j);
    // Iterate i to node with distance >= pivot
    do {
      i++;
    } while ( nodes[i]->distance < pivot );
    /*
    while ( nodes[i]->distance < pivot &&
	    i < (j-1) ) {
      i++;
      if (i == (j-1)) {
	break;
      }
    }
    */
    // Iterate j to node with distance <= pivot
    do {
      j--;
    } while ( nodes[j]->distance > pivot );
    /*
    while ( nodes[j]->distance >= pivot &&
	    i < (j-1) ) {
      j--;
      if (i == (j-1)) {
	break;
      }
    }
    */
    //if (i == (j-1)) {
    if (i<j) {
      //flag++;
      //if (nodes[i]->distance > nodes[j]->distance) {
      NeuronNode* tempNode = nodes[i];
      nodes[i] = nodes[j];
      nodes[j] = tempNode;
      //}
    }
    else {
      flag++;
    }
    // if (distance of i > distance of j) switch them
    //if (nodes[i]->distance > nodes[j]->distance) {
    //else {
    //  NeuronNode* tempNode = nodes[i];
    //  nodes[i] = nodes[j];
    //  nodes[j] = tempNode;
    //}
    //}
  }

  // Quicksort lower segment
  if (first < j) {
    quicksortNodes(first,j);
  }

  // Quicksort higher segment
  if (j+1 < last) {
    quicksortNodes(j+1,last);
  }

  //printf("<=NeuronList::quicksortNodes(%d,%d)\n",first,last);

  return 1;
}


// checkOrder
//   DEBUG METHOD to check list ordering after quicksort
int NeuronList::checkOrder() {

  int c = 0;

  for (int i=0; i<neuronCount-1; i++) {
    if (nodes[i]->distance > nodes[i+1]->distance) {
      printf("   nodes[%d]->distance = %f; nodes[%d]->distance = %f\n",i,nodes[i]->distance,i+1,nodes[i+1]->distance);
      c++;
    }
  }

  //printf("   Order Errors: %d\n",c);

  return 1;
}
