
#ifndef PDBREADER_H
#define PDBREADER_H

//#include "alphabet.h"
#include "atomCluster.h"
#include "coordinate3D.h"
#include "elementBuilder.h"
//#include "structure.h"
//#include "symbol.h"
#include "typeConvert.h"

#include <stdio.h>

class PdbReader {

 public:
  /** Constructor. */
  PdbReader();
  //PdbReader(Alphabet* alpha);

  /** Destructor. */
  ~PdbReader();


  /** */
  int setFilename(char* fn);

  /**
   *
   * @param p char*: Path to pdb file.
   * @return int: 0 on fail, 1 on success.
   */
  int setPath(char* p);

  /**
   *
   * @param structIndex int:
   * @param eb ElementBuilder*: 
   * @return AtomCluster*: atoms in the pdb file.
   */
  AtomCluster* getAtomCluster(int structIndex, ElementBuilder* eb);
  //Structure* getStructure(int structIndex);
  //Structure* getNextStructure();

  //AlignedStructure* getAlignedSequence(int seqIndex);
  //AlignedStructure* getNextAlignedSequence();
  //SequenceAlignment* getSequenceAlignment();

  /**
   *
   * @return int: 0 on fail, 1 on success.
   */
  int getStructureCount();

  //int getElementCount();

  /**
   *
   * @return int: 0 on fail, 1 on success.
   */
  int getAtomCount();

 private:

  /**
   * 
   * @param str char*: 
   * @return Coordinate3D*: 
   */
  Coordinate3D* readCoordinate3DFromFile(char* str);

  /**
   *
   * @return int: 0 on fail, 1 on success.
   */
  int checkFullName();

  /**
   * Verify that a file corresponding to the current filename exists.
   * @param file char*: pdb file.
   * @return int: 0 on fail, 1 on success.
   */
  int checkPdbFile(char* file);

  /**
   * 
   * @return int: 0 on fail, 1 on success.
   */
  int setNameFromFilename();

 private:
  //Alphabet* alphabet;
  char* filename;
  char* path;      // Path to the file
  char* fullName;
  char* structureName;
  //int currentSequence;

};

#endif
