
//#include "atom.h"
//#include "atomCluster.h"
//#include "box.h"
//#include "connectionMatrix.h"
#include "coordinate3D.h"
//#include "element.h"
//#include "elementBuilder.h"
#include "neuronList.h"
//#include "pdbReader.h"
//#include "tessellator.h"

#include <stdio.h>
#include <stdlib.h>


int main (int argc, char** argv) {

  Coordinate3D* coord1 = new Coordinate3D(0.0,0.0,0.0);
  Coordinate3D* coord2 = new Coordinate3D(0.0,10.0,10.0);
  Coordinate3D* coord3 = new Coordinate3D(10.0,0.0,10.0);
  Coordinate3D* coord4 = new Coordinate3D(10.0,10.0,0.0);
  Coordinate3D* coord5 = new Coordinate3D(20.0,10.0,10.0);
  Coordinate3D* coord6 = new Coordinate3D(20.0,0.0,0.0);
  
  printf("*** NeuronList Test ***\n");
  Coordinate3D** coordArray = new Coordinate3D*[6];
  coordArray[0] = coord1;
  coordArray[1] = coord2;
  coordArray[2] = coord3;
  coordArray[3] = coord4;
  coordArray[4] = coord5;
  coordArray[5] = coord6;

  printf("   Hey\n");
  Coordinate3D* focus = new Coordinate3D(5.0, 7.0, 9.0);
  NeuronList* neuronList = new NeuronList(coordArray, 6, focus);
  int index1 = neuronList->getFirstIndex();
  int index2 = neuronList->getSecondIndex();
  printf("  index1 = %d\n",index1);
  printf("  index2 = %d\n",index2);
  printf("coordinates:\n");
  for (int i=0; i<6; i++) {
    printf("  graphics $mol sphere {%3.2f %3.2f %3.2f} radius 0.6 resolution 12\n",coordArray[i]->getX(),coordArray[i]->getY(),coordArray[i]->getZ());
  }

  printf("focus:\n  graphics $mol sphere {%3.2f %3.2f %3.2f} radius 0.6 resolution 12\n",focus->getX(),focus->getY(),focus->getZ());
  neuronList->contract(0.8, 1.2);
  printf("\nContract\n");
  printf("coordinates:\n");
  for (int i=0; i<6; i++) {
    printf("  graphics $mol sphere {%3.2f %3.2f %3.2f} radius 0.6 resolution 12\n",coordArray[i]->getX(),coordArray[i]->getY(),coordArray[i]->getZ());
  }

  delete neuronList;

  printf("\n\n");

  return 0;
}
